function Adm03000_ReNotasFiscais_Controller(Adm03000_ReNotasFiscais_Service, ScreenService, General) {
    let widget;
    let REService = Adm03000_ReNotasFiscais_Service;

    this.checaTodosSomatorios = function(widget) {
        return this.checaSomatorio('NRCOUNTCGC', widget.getField("SOMACGC"))   &&
               this.checaSomatorio('NRCOUNTEMIS', widget.getField("SOMAEMIS")) &&
               this.checaSomatorio('VRTOTANOTA', widget.getField("SOMATOTA"))  &&
               this.checaSomatorio('NRCOUNTNUM', widget.getField("SOMANUMNF"));
    };

    this.geraRelatorio = function(widget) {
        if(widget.isValid() && this.checaTodosSomatorios(widget)) {
            if(widget.currentRow.IDENTRSAID === 'E') {
                if(REService.checaNotaEmpty()) {
                    ScreenService.showMessage('Não há dados a serem listados.');
                    return;
                }
            }

            widget.filter = new Object({});

            widget.filter.CDALMOXARIFE = widget.currentRow.CDALMOXARIFE || null;
            widget.filter.TAMNVTOT = widget.currentRow.TAMNVTOT;
            widget.filter.DATARE = widget.currentRow.DATARE;
            widget.filter.CDLOCALESTOQ = widget.currentRow.CDLOCALESTOQ || null;
            widget.filter.CDFILIAL = widget.currentRow.CDFILIAL;
            widget.filter.IDENTRSAID = widget.currentRow.IDENTRSAID;
            widget.filter.IDRETIICMS = widget.currentRow.IDRETIICMS;
            widget.filter.SALDOANT = widget.currentRow.SALDOANT || 0;
            widget.filter.TOTENTR = widget.currentRow.TOTENTR || 0;
            widget.filter.TOTSAID = widget.currentRow.TOTSAID || 0;
            widget.filter.__report_name = widget.currentRow.REPORT_NAME;

            REService.getNrorg().then(function(nrorg) {
                widget.filter.NRORG = nrorg;

                REService.buidlFilter(widget.filter).then(function(birtURL) {
                    window.open(birtURL.messages[0].message);
                }, function(error) {
                    ScreenService.showMessage(error.data.error);
                });
            });
        }
    };

    this.setParametersFilialLoagada = function(widgetGrid) {
        REService.setParametersFilial().then(function(params) {
            widget = widgetGrid;

            widget.currentRow.CDFILIAL = params[1];
            widget.getField('NMFILIAL').setValue(params[2]);
            widget.currentRow.IDRETIICMS = 'N';

            this.setReadAlmox(params[0]);
            this.setDataRe(params[3]);
            this.setReadSomato(widget.currentRow.IDENTRSAID);
        }.bind(this), function(error) {
            ScreenService.showMessage(error.data.error);
        });
    };

    this.setParametersFilial = function() {
        widget.getField('DSALMOXARIFE').readOnly = true;
        widget.getField('DSALMOXARIFE').setValue(null);

        widget.getField('DSLOCALESTOQ').readOnly = true;
        widget.getField('DSLOCALESTOQ').setValue(null);

        widget.getField('DATARE').setValue(null);

        widget.getField('SOMACGC').setValue(null);
        widget.getField('SOMAEMIS').setValue(null);
        widget.getField('SOMATOTA').setValue(null);
        widget.getField('SOMANUMNF').setValue(null);

        REService.setParametersFilial().then(function(params) {
            this.setReadAlmox(params[0]);
            this.setDataRe(params[3]);
            this.setReadSomato(widget.currentRow.IDENTRSAID);
        }.bind(this), function(error) {
            ScreenService.showMessage(error.data.error);
        });
    };

    this.setParamNota = ({CDFILIAL, CDALMOXARIFE = null, CDLOCALESTOQ = null, DATARE, IDENTRSAID}) =>
        REService.setParamNota(CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, DATARE)
            .then(this.setReadSomato.bind(this, IDENTRSAID))
            .catch(({data: {error: errorMessage}}) => ScreenService.showMessage(errorMessage));

    this.setReadAlmox = function(readOnly) {
        if(readOnly) {
            widget.getField('DSALMOXARIFE').readOnly = false;
            widget.getField('DSALMOXARIFE').reload();
        } else {
            widget.CDALMOXARIFE = ' ';
        }
    };

    this.setDataRe = function(data) {
        widget.getField('DATARE').setValue(data);
        widget.getField('DATARE').maxDate = data;
    };

    this.setReadLocal = function(value) {
        if(value === null) {
            widget.getField('DSLOCALESTOQ').readOnly = true;
        } else if(REService.checaUtilizaLocal()) {
            widget.getField('DSLOCALESTOQ').readOnly = false;
            widget.getField('DSLOCALESTOQ').reload();
        }
    };

    this.setReadSomato = function(value) {
        if(value === "E") {
            
            if(REService.allInvoicesImportedByXML())
                blockSumFields(widget);
            else {
                if(REService.checaIdconscgcre()) {
                    widget.getField('SOMACGC').readOnly = false;
                    setRequired(true, 'SOMACGC');
                } else {
                    widget.getField('SOMACGC').setValue(null);
                    setRequired(null, 'SOMACGC');
                }

                if(REService.checaIdconsemisre()) {
                    widget.getField('SOMAEMIS').readOnly = false;
                    setRequired(true, 'SOMAEMIS');
                } else {
                    widget.getField('SOMAEMIS').setValue(null);
                    setRequired(null, 'SOMAEMIS');
                }

                if(REService.checaIdconstotare()) {
                    widget.getField('SOMATOTA').readOnly = false;
                    setRequired(true, 'SOMATOTA');
                } else {
                    widget.getField('SOMATOTA').setValue(null);
                    setRequired(null, 'SOMATOTA');
                }

                if(REService.checaIdconsnumere()) {
                    widget.getField('SOMANUMNF').readOnly = false;
                    setRequired(true, 'SOMANUMNF');
                } else {
                    widget.getField('SOMANUMNF').setValue(null);
                    setRequired(null, 'SOMANUMNF');
                }
            }
        } else
            blockSumFields(widget);
    };

    const blockSumFields = widget => {
        const sumFields = ['SOMACGC', 'SOMAEMIS', 'SOMATOTA', 'SOMANUMNF'];
        const clearField = fieldName => {
            widget.getField(fieldName).readOnly = true;
            widget.getField(fieldName).setValue(null);
            setRequired(null, fieldName);
        };

        sumFields.forEach(clearField);
    };

    this.setDataIfMaskForTamNivel = function(field) {
        var levels = General.getLevelByMask("GER_CDPICTPROD", 1);

        for(var index in levels) {
            if(levels.hasOwnProperty(index)) {
                field.dataSource.data.push({
                    "name": levels[index].nivel,
                    "value": levels[index].nivel
                });
            }
        }

        field.setValue(1);
        this.setDefaultValue(field.widget);
    };

    this.reportSelect = function(value) {
        if(value === 'ADM03001') {
            widget.getField('IDENTRSAID').setValue('S');
            widget.getField('IDENTRSAID').readOnly = true;

            this.setReadSomato(widget.currentRow.IDENTRSAID);
        } else {
            widget.getField('IDENTRSAID').readOnly = false;
        }
    };

    const setRequired = (required, fieldName) => {
        if(required)
            widget.getField(fieldName).validations.required = true;
        else
            delete widget.getField(fieldName).validations.required;
    };

    this.checaSomatorio = function(nameSomatorio, field) {
        if(field.value() !== null) {
            if(nameSomatorio === 'NRCOUNTCGC') {
                if(REService.getValueValidSoma('NRCOUNTCGC') !== null) {
                    if(field.value() != REService.getValueValidSoma('NRCOUNTCGC')) {
                        field.setValue(null);

                        ScreenService.showMessage('Somatório do controle de C.G.C/C.P.F difere do cadastro.');
                        return false;
                    }
                } else if(parseFloat(field.value()) !== 0) {
                    field.setValue(null);

                    ScreenService.showMessage('Somatório do controle de C.G.C/C.P.F difere do cadastro.');
                    return false;
                }
            } else if(nameSomatorio === 'NRCOUNTEMIS') {
                if(REService.getValueValidSoma('NRCOUNTEMIS') !== null) {
                    if(field.value() != REService.getValueValidSoma('NRCOUNTEMIS')) {
                        field.setValue(null);

                        ScreenService.showMessage("Somatório dos dias da emissão de NFs difere do cadastro.");
                        return false;
                    }
                } else if(parseFloat(field.value()) !== 0) {
                    field.setValue(null);

                    ScreenService.showMessage("Somatório dos dias da emissão de NFs difere do cadastro.");
                    return false;
                }
            } else if(nameSomatorio === 'VRTOTANOTA') {
                if(REService.getValueValidSoma('VRTOTANOTA') !== null) {
                    var value = '';

                    if(field.value().search(',') != -1) {
                        value = parseFloat(field.value().replace(/\./g, '').replace(',', '.'));
                    } else {
                        value = parseFloat(field.value());
                    }

                    if(value - REService.getValueValidSoma('VRTOTANOTA') > 0.05 
                    || value - REService.getValueValidSoma('VRTOTANOTA') < -0.05) {
                        field.setValue(null);

                        ScreenService.showMessage("Somatório dos valores totais das NFs difere do cadastro.");
                        return false;
                    }
                } else if(parseFloat(field.value()) !== 0) {
                    field.setValue(null);

                    ScreenService.showMessage("Somatório dos valores totais das NFs difere do cadastro.");
                    return false;
                }
            } else if(nameSomatorio === 'NRCOUNTNUM') {
                if(REService.getValueValidSoma('NRCOUNTNUM') !== null) {
                    if(field.value() != REService.getValueValidSoma('NRCOUNTNUM')) {
                        field.setValue(null);

                        ScreenService.showMessage("Somatório dos números das NFs difere do cadastro.");
                        return false;
                    }
                } else if(parseFloat(field.value()) !== 0) {
                    field.setValue(null);

                    ScreenService.showMessage("Somatório dos números das NFs difere do cadastro.");
                    return false;
                }
            }

            return true;
        } else
            return !!field.readOnly && !(field.validations && field.validations.required);
    };

    this.setDefaultValue = function(widget) {
        widget.getField('REPORT_NAME').setValue('ADM03000');
        widget.getField('IDENTRSAID').setValue('E');
        widget.getField('IDRETIICMS').setValue('S');
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Adm03000_ReNotasFiscais_Controller', Adm03000_ReNotasFiscais_Controller);
});
