var Dfe23000_ComprasRealizadasPorMes_Controller = function(templateManager, ScreenService,  General, Dfe23000_ComprasRealizadasPorMes_Service, ZhFilterPreferences, ZHPromise, restEngine) {

    var openSwipe = false;
    var lastTotalizer = {};
    var lastTotalizerIndex = -1;

    this.openFilterCompras = function(widget){
        General.callRestEngine("df#/crud/filial", "FilterData", [{name: "CDFILIAL", operator: "=", value: "FILIAL_LOGADA"}]).then((success) => {
            var row = Util.clone(widget.currentRow);

            row.CDFILIAL = success.dataset.filial[0].CDFILIAL;
            row.NMFILIAL = success.dataset.filial[0].NMFILIAL;
            
            var dataAtual = formatarData(new Date());
                    
            var date = new Date();
            var primeiroDia = new Date(date.getFullYear(), date.getMonth(), 1);
            var ultimoDia = new Date(date.getFullYear(), date.getMonth() + 1, 0);
            
            row.DTENTRSAID       = {};
            row.DTENTRSAID.start = formatarData(primeiroDia);
            row.DTENTRSAID.end   = formatarData(ultimoDia);
                
            row.REPORT_NAME   = 'DFE32001';
            setLocalVar("REPORT_NAME", 'DFE32001');
            
            ZhFilterPreferences.setOriginalFilter(widget.id, row);
            ZhFilterPreferences.openFilterWidget(widget, row);
        },
        (error) => {
            ZhFilterPreferences.openFilterWidget(widget);
            console.log(error);
        });
    };
    
    function formatarData(data) {
        var d = new Date(data),
        mes = '' + (d.getMonth() + 1),
        dia = '' + d.getDate(),
        ano = d.getFullYear();
    
        if (mes.length < 2) mes = '0' + mes;
        if (dia.length < 2) dia = '0' + dia;
    
        return [dia, mes, ano].join('/');
    }
    
    this.setReportName = function(){
        var reportName = templateManager.container.getActiveWidget().getField('REPORT_NAME').value();
        setLocalVar("REPORT_NAME", reportName);
    };
    
	this.activateTab = function(widget) {
		if (!!openSwipe) {
			widget.activate();
			openSwipe = false;
		}
	};

    this.verAlmox = function(widget) {
        if(widget.currentRow.REPORT_NAME === 'DFE32004') {
            var currentRow = widget.currentRow;
            var fieldAmox = widget.getField('DSALMOXARIFE');
            if(currentRow.CDFILIAL){
                Dfe23000_ComprasRealizadasPorMes_Service.setParamFilial(currentRow.CDFILIAL).then(function(success) {
                    if(Dfe23000_ComprasRealizadasPorMes_Service.utilizaAlmox()){
                        fieldAmox.readOnly = false;
                    }  else {
                        fieldAmox.readOnly = true;
                    }
                    fieldAmox.setValue(null);
                }.bind(this), function(error) {
                    ScreenService.showMenssage(error.data.error);
                });
            } else {
                delete fieldAmox.validations.required;
                fieldAmox.readOnly = true;
                fieldAmox.setValue(null);
            }
        }
    };

    this.setMinMax = function(widget, fieldNameSet, fieldNameGet, minOrMax){
        if(minOrMax == 'max') {
            widget.getField(fieldNameSet).maxDate = widget.getField(fieldNameGet).value();
        } else {
            widget.getField(fieldNameSet).minDate = widget.getField(fieldNameGet).value();
        }
    };

    this.selectDataSource = function(args){
        args.e.preventDefault();
        var widgetByReport = templateManager.container.getWidget('widget_by_report');
        var widget = args.owner;
        
        var filterDefault = {
            name: '',
            operator: '=',
            value: ''
        };
        
        var filters = [];
        
           
        var cdprodini = {
            name: "CDPRODINI",
            value: args.owner.appliedFilter.FILTER_ROW.CDPRODINI, 
            operator: "="
        };
        
        var cdprodfim = {
            name: "CDPRODFIM",
            value: this.getProdFinMask(args.owner.appliedFilter.FILTER_ROW.CDPRODFIM), 
            operator: "="
        };
        
        filters.push(cdprodini);
        filters.push(cdprodfim);
        
        
        if(args.e.preference.FILTER_ROW.REPORT_NAME === 'DFE32001'){ //Compras Realizadas por Mês (ordenado por Mês)
            widgetByReport.dataSource.name = 'df_relatorios#/notafiscal_compras_realizadas_report_data';
            widget.dataSource.name = 'df_relatorios#/notafiscal_compras_realizadas_ordem_mes';
            widget.order = 'DATA';
            widget.getField('MES').isVisible = true;
            widget.getField('DATA').isVisible = true;
            widget.getField('CDARVPROD').isVisible = false;
            widget.getField('NMPRODUTO').isVisible = false;
            widget.getField('SGUNIDADE').isVisible = false;
        } else {                                          //Compras Realizadas por Mês (ordenado por Produto)
            widgetByReport.dataSource.name = 'df_relatorios#/notafiscal_compras_realizadas_report_prod';
            widget.dataSource.name = 'df_relatorios#/notafiscal_compras_realizadas_ordem_produto';
            widget.order = 'CDARVPROD';
            widget.getField('MES').isVisible = false;
            widget.getField('DATA').isVisible = false;
            widget.getField('CDARVPROD').isVisible = true;
            widget.getField('NMPRODUTO').isVisible = true;
            widget.getField('SGUNIDADE').isVisible = true;
        }
        widget.dataSourceFilter.forEach((filter) => {
            if(filter.name != 'REPORT_NAME' 
                && filter.name != 'CDPRODINI'
                && filter.name != 'CDPRODFIM'
                && filter.name != 'DTENTRSAID' 
                && filter.name != 'DTEMISSAO'
                && filter.name != 'DTENTRSAIDINI'
                && filter.name != 'DTENTRSAIDFIN'
                && filter.name != 'DTEMISSAOINI'
                && filter.name != 'DTEMISSAOFIN'
                && filter.name != 'T_DTEMISSAO'
                && filter.name != 'T_DTENTRSAID'){
                    delete filter.isCustomFilter;
                    filters.push(filter);
            }
        });
        
        var dtEntrSaid = templateManager.container.getActiveWidget().appliedFilter.FILTER_ROW.DTENTRSAID;
        var dtEmissao  = templateManager.container.getActiveWidget().appliedFilter.FILTER_ROW.DTEMISSAO;
        
        filterDefault.name  = 'DTENTRSAIDINI';
        filterDefault.value =  dtEntrSaid ? (dtEntrSaid.start || '') : '' ;
        filters.push(Util.clone(filterDefault));
        filterDefault.name  = 'DTENTRSAIDFIN';
        filterDefault.value =  dtEntrSaid ? (dtEntrSaid.end || '') : '' ;
        filters.push(Util.clone(filterDefault));
        
        filterDefault.name  = 'T_DTENTRSAID';
        filterDefault.value = dtEntrSaid ? ((dtEntrSaid.start) ? '' : 'T') : 'T' ;
        filters.push(Util.clone(filterDefault));
            

        filterDefault.name  = 'DTEMISSAOINI';
        filterDefault.value = dtEmissao ? (dtEmissao.start || '') : '' ;
        filters.push(Util.clone(filterDefault));
        
        filterDefault.name  = 'DTEMISSAOFIN';
        filterDefault.value = dtEmissao ? (dtEmissao.end || '') : '' ;
        filters.push(Util.clone(filterDefault));
        
        filterDefault.name  = 'T_DTEMISSAO';
        filterDefault.value = dtEmissao ? ((dtEmissao.start) ? '' : 'T') : 'T' ;
        filters.push(Util.clone(filterDefault));

        this.buildGrid(args.e.preference.FILTER_ROW.REPORT_NAME);
        widget.resizeGridColumns(true);
        
        widget.dataSourceFilter = filters;
        
        widget.reload();
        widget.redraw();
        
        
    };
    
    this.getProdFinMask = function(value) {

        var mascara = getLocalVar('GER_CDPICTPROD');
        mascara = mascara.split('.');
        var mascaraSemPonto =  "";
        for(var index in mascara){
            mascaraSemPonto = mascaraSemPonto + mascara[index];
        }
        mascara = mascaraSemPonto.length;
        var tamanhoValue = value.length;
        mascara = mascara - tamanhoValue;
        var maximo = 'z';
        value += maximo.repeat(mascara);
        
        return value;
    };
    
    this.validateFilterPopup = function(args) {
        
        var row = args.e.preference.FILTER_ROW;
        
        if(!row.DTENTRSAID && !row.DTEMISSAO) {
            ScreenService.showMessage('Data de entrada e/ou data de emissão devem ser informadas!');
            args.e.preventDefault();
        }
        else {
            General.validateFilterPopup(args);
        }
    };

    this.buildGrid = function(report){
        var widget = templateManager.container.getWidget('widget_by_report');
        var fieldAgrupa = widget.getField('AGRUPA');
        if(report === 'DFE32002') {//ORDENADOR POR PRODUTO
            fieldAgrupa.label = 'Produto';
            fieldAgrupa.template = 'field/text-edit.html';
            if(fieldAgrupa.dateFormat)
                delete fieldAgrupa.dateFormat;
            if(fieldAgrupa.displayFormat)
                delete fieldAgrupa.displayFormat;
        } else {//ORDENADO POR MÊS
            fieldAgrupa.label = 'Mês';
            fieldAgrupa.template = 'field/calendar.html';
                fieldAgrupa.dateFormat = 'DD/MM/YYYY';
            fieldAgrupa.displayFormat = 'MM/YYYY';
            
        }
    };

    this.buildGridAgruped = function(args, widget, event){
        this.lastTotalizerIndex = false;
        var widgetFilha = widget.widgets[0];
        var report;
        var dtIniMes, dtFinMes;
        
        if(event == "WidgetAfterMoveRow"){
            report = getLocalVar('REPORT_NAME');
        }else{
            report = args.e.preference.FILTER_ROW.REPORT_NAME;
        }
        //monta o filtro da widget filha conforme a row e o time do relatório
        widgetFilha.dataSourceFilter = angular.copy(widget.dataSourceFilter);
        
        let index_T_DTEMISSAO = widgetFilha.dataSourceFilter.findIndex(index => {
            if(index.name == 'DTEMISSAOINI'){
                return index;
               
        }});
        
        if(widgetFilha.dataSourceFilter[index_T_DTEMISSAO].value != ''){
            widgetFilha.dataSourceFilter.forEach(filter => {
                if(report === 'DFE32001') {
                    if(filter.name === 'DTENTRSAIDINI'){
                        dtIniMes = moment(widget.currentRow.DATA, 'DD/MM/YYYY');
                        if(dtIniMes.startOf('month').isAfter(moment(filter.value, 'DD/MM/YYYY'))) {
                             filter.value = moment(widget.currentRow.DATA, 'DD/MM/YYYY').startOf('month').format('DD/MM/YYYY');
                        }
                    } else if(filter.name === 'DTENTRSAIDFIN'){
                        dtFinMes = moment(widget.currentRow.DATA, 'DD/MM/YYYY');
                        if(dtFinMes.endOf('month').isBefore(moment(filter.value, 'DD/MM/YYYY'))) {
                             filter.value = moment(widget.currentRow.DATA, 'DD/MM/YYYY').endOf('month').format('DD/MM/YYYY');
                        }
                    }
                }
                else {
                    if( filter.name === 'CDPRODINI'){
                        filter.value = widget.currentRow.CDARVPROD;
                    } else if( filter.name === 'CDPRODFIM'){
                        filter.value = widget.currentRow.CDARVPROD;
                    }
                }
            });
            
        }else{
            widgetFilha.dataSourceFilter.forEach(filter => {

            if(report === 'DFE32001') {
                if(filter.name === 'DTENTRSAIDINI'){
                    dtIniMes = moment(widget.currentRow.DATA, 'DD/MM/YYYY');
                    if(dtIniMes.startOf('month').isAfter(moment(filter.value, 'DD/MM/YYYY'))) {
                         filter.value = moment(widget.currentRow.DATA, 'DD/MM/YYYY').startOf('month').format('DD/MM/YYYY');
                    }
                } else if(filter.name === 'DTENTRSAIDFIN'){
                    dtFinMes = moment(widget.currentRow.DATA, 'DD/MM/YYYY');
                    if(dtFinMes.endOf('month').isBefore(moment(filter.value, 'DD/MM/YYYY'))) {
                         filter.value = moment(widget.currentRow.DATA, 'DD/MM/YYYY').endOf('month').format('DD/MM/YYYY');
                    }
                }
                else if( filter.name === 'DTEMISSAOINI') {
                    filter.value = '';
                } else if (filter.name === 'DTEMISSAOFIN') {
                    filter.value = '';
                } else if(filter.name === 'T_DTEMISSAO') {
                    filter.value = 'T';
                }  
            }
            else {
                if( filter.name === 'CDPRODINI'){
                    filter.value = widget.currentRow.CDARVPROD;
                } else if( filter.name === 'CDPRODFIM'){
                    filter.value = widget.currentRow.CDARVPROD;
                }
            }
        });
        }
            
        //Troca a label conforme a row
        if(report === 'DFE32001'){
            widgetFilha.label = widget.currentRow.MES + '/' + moment(widget.currentRow.DATA, 'DD/MM/YYYY').format('YYYY');
        } else {
            widgetFilha.label = widget.currentRow.NMPRODUTO;
        }
		openSwipe = true;
		widgetFilha.reload();
    };

    this.generateReport = function(reportType){
        var widgetByReport = templateManager.container.getWidget('widget_by_report');
        var widget = templateManager.container.getWidget('dfe23000_compras_realizadas_por_mes_grid');
        widgetByReport.dataSourceFilter = widget.dataSourceFilter;
        widgetByReport.reload().then(function() {
            widgetByReport.generateReport(widgetByReport, reportType);
        });
    };

    this.closeSwipe =function(widget){
        ScreenService.goBack();
        widget.parent.reload();
    };
    
    this.produtoFinalIsValid = function(widget) {
	    if(widget.currentRow.CDPRODUTOFIM && widget.currentRow.CDPRODUTOINI) {
    		if(widget.currentRow.CDPRODUTOFIM < widget.currentRow.CDPRODUTOINI) {
    			ScreenService.showMessage(ScreenService.i18n("Produto inicial deve ser menor ou igual ao produto final."));
    			widget.currentRow.CDPRODUTOFIM = null;
    			widget.currentRow.NMPRODFINAL = null;
    		}
    	widget.currentRow.CDPRODUTOFIM = widget.currentRow.CDPRODUTOFIM + "zzzzzzzzzz";
        widget.currentRow.CDPRODUTOFIM = widget.currentRow.CDPRODUTOFIM.substring(0, 10);
        widget.currentRow.CDPRODFIM = widget.currentRow.CDPRODFIM + "zzzzzzzzzz";
        widget.currentRow.CDPRODFIM = widget.currentRow.CDPRODFIM.substring(0, 10);
	    }
	};

	this.produtoInicialIsValid = function(widget) {
	    if(widget.currentRow.CDPRODUTOFIM && widget.currentRow.CDPRODUTOINI) {
    		if(widget.currentRow.CDPRODUTOFIM < widget.currentRow.CDPRODUTOINI) {
    			ScreenService.showMessage(ScreenService.i18n("Produto inicial deve ser menor ou igual ao produto final."));
    			widget.currentRow.CDPRODUTOINI = null;
    			widget.currentRow.NMPRODINICIO = null;
    		}
	    }
	};
	
	this.saveLastTotalizer = function(widget) {
	    if(widget.dataSource.data) {
    	    let length = widget.dataSource.data.length;
	        let total  = widget.dataSource.data[length - 1];
	        
	        this.lastTotalizer = total;
	        this.lastTotalizerIndex = total;
	    }    
	};
	
	this.totalizer = function(widget) {    
	    let length = widget.dataSource.data.length;
        let total  = widget.dataSource.data[length - 1];
	    
        
        if(this.lastTotalizerIndex) {
	        let { QUANTIDADE, VALORTOTAL } = widget.dataSource.data[this.lastTotalizerIndex];

            total.VALORTOTAL += VALORTOTAL;
            total.QUANTIDADE += QUANTIDADE;
            widget.dataSource.data = [  
                        ...widget.dataSource.data.slice(0, this.lastTotalizerIndex), 
                        ...widget.dataSource.data.slice(this.lastTotalizerIndex + 1, widget.dataSource.data.length)
            ];
            this.lastTotalizerIndex = widget.dataSource.data.length - 1;
        }  
        else {
            
            this.lastTotalizerIndex = length - 1;
            
        }           

	};

};

Configuration(function(ContextRegister) {
    ContextRegister.register('Dfe23000_ComprasRealizadasPorMes_Controller', Dfe23000_ComprasRealizadasPorMes_Controller);
});